



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>网络编程基础API</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">网络编程基础API</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-29 04:32:07 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h3>1.预备知识</h3>
<p><strong>网络字节序</strong><br /><br />
1.TCP/IP协议规定，网络数据流应采用大端字节序<br /><br />
0x12345678<br /><br />
小端存储：78存储在低地址<br /><br />
大端存储：12存储在低地址<br /><br />
<strong>网络字节序和主机字节序的转换</strong></p>
<pre class="prettyprint linenums"><code>#include &lt;arpa/inet.h&gt;<br />
uint32_t htonl(uint32_t hostlong);<br />
uint16_t htons(uint16_t hostshort);<br />
uint32_t ntohl(uint32_t netlong);<br />
uint16_t ntohs(uint16_t netshort);<br />
h表示host，n表示network，l(long)表示32位长整数，s(short)表示16位短整数。<br />
如果主机是小端字节序，这些函数将参数做相应的大小端转换然后返回，如果主机是大端字节序，这些函数不做转<br />
换，将参数原封不动地返回。<br />
</code></pre>
<p><strong>IP地址转换函数</strong><br /><br />
192.168.56.101这就是一个字符串，要把这个字符串转换成32位的ip地址</p>
<pre class="prettyprint linenums"><code>#include &lt;arpa/inet.h&gt;<br />
int inet_pton(int af, const char *src, void *dst);<br />
const char *inet_ntop(int af, const void *src, char *dst, socklen_t size);<br />
支持IPv4和IPv6<br />
可重入函数<br />
</code></pre>
<h3>2.网络套接字函数</h3>
<h4>1.socket</h4>
<pre class="prettyprint linenums"><code>#include &lt;sys/types.h&gt; /* See NOTES */<br />
#include &lt;sys/socket.h&gt;<br />
int socket(int domain, int type, int protocol);<br />
domain:<br />
AF_INET 这是大多数用来产生socket的协议，使用TCP或UDP来传输，用IPv4的地址<br />
AF_INET6 与上面类似，不过是来用IPv6的地址<br />
AF_UNIX 本地协议，使用在Unix和Linux系统上，一般都是当客户端和服务器在同一台及其上的时候使用<br />
type:<br />
SOCK_STREAM 这个协议是按照顺序的、可靠的、数据完整的基于字节流的连接。这是一个使用最多的socket类<br />
型，这个socket是使用TCP来进行传输。<br />
SOCK_DGRAM 这个协议是无连接的、固定长度的传输调用。该协议是不可靠的，使用UDP来进行它的连接。<br />
SOCK_SEQPACKET 这个协议是双线路的、可靠的连接，发送固定长度的数据包进行传输。必须把这个包完整的<br />
接受才能进行读取。<br />
SOCK_RAW 这个socket类型提供单一的网络访问，这个socket类型使用ICMP公共协议。（ping、traceroute使<br />
用该协议）<br />
SOCK_RDM 这个类型是很少使用的，在大部分的操作系统上没有实现，它是提供给数据链路层使用，不保证数<br />
据包的顺序<br />
protocol:<br />
0 默认协议<br />
返回值：<br />
成功返回一个新的文件描述符，失败返回-1，设置errno<br />
</code></pre>
<p>socket()打开一个网络通讯端口，如果成功的话，就像open()一样返回一个文件描述符，应用程序可以像读写文件一样用read/write在网络上收发数据，如果socket()调用出错则返回-1。对于IPv4，domain参数指定为AF_INET。对于TCP协议，type参数指定为SOCK_STREAM，表示面向流的传输协议。如果是UDP协议，则type参数指定为SOCK_DGRAM，表示面向数据报的传输协议。protocol参数的介绍从略，指定为0即可。</p>
<h3>2.bind函数</h3>
<pre class="prettyprint linenums"><code>#include &lt;sys/types.h&gt; /* See NOTES */<br />
#include &lt;sys/socket.h&gt;<br />
int bind(int sockfd, const struct sockaddr *addr, socklen_t addrlen);<br />
sockfd：<br />
socket文件描述符<br />
addr:<br />
构造出IP地址加端口号<br />
addrlen:<br />
sizeof(addr)长度<br />
返回值：<br />
成功返回0，失败返回-1, 设置errno<br />
</code></pre>
<p>bind函数的第二个参数是由于历史原因决定的，其实完全可以写成void*类型，然后根据前16为类决定是哪一类的地址。</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/739465/201511/739465-20151129090330532-1373737269.png"></p>
<p>服务器程序所监听的网络地址和端口号通常是固定不变的，客户端程序得知服务器程序的地址和端口号后就可以向服务器发起连接，因此服务器需要调用bind绑定一个固定的网络地址和端口号。bind()的作用是将参数sockfd和addr绑定在一起，使sockfd这个用于网络通讯的文件描述符监听addr所描述的地址和端口号。前面讲过，struct sockaddr *是一个通用指针类型，addr参数实际上可以接受多种协议的sockaddr结构体，而它们的长度各不相同，所以需要第三个参数addrlen指定结构体的长度。如：</p>
<pre class="prettyprint linenums"><code>struct sockaddr_in servaddr;<br />
bzero(&amp;servaddr, sizeof(servaddr));<br />
servaddr.sin_family = AF_INET;<br />
servaddr.sin_addr.s_addr = htonl(INADDR_ANY);//INADDR_ANY表示本机的任意的ip地址，可能有好几个网卡。<br />
servaddr.sin_port = htons(8000);<br />
</code></pre>
<p>首先将整个结构体清零，然后设置地址类型为AF_INET，网络地址为INADDR_ANY，这个宏表示本地的任意IP地址，因为服务器可能有多个网卡，每个网卡也可能绑定多个IP地址，这样设置可以在所有的IP地址上监听，直到与某个客户端建立了连接时才确定下来到底用哪个IP地址，端口号为8000。</p>
<h3>3.listen：不要从字面意思理解，这个listen的意思是socket文件描述符去具备监听的能力。</h3>
<pre class="prettyprint linenums"><code>#include &lt;sys/types.h&gt; /* See NOTES */<br />
#include &lt;sys/socket.h&gt;<br />
int listen(int sockfd, int backlog);<br />
sockfd:<br />
socket文件描述符<br />
backlog:<br />
排队建立3次握手队列和刚刚建立3次握手队列的链接数和(内核维护的两个队列)<br />
listen函数后面维护了两个队列，一个是完成3次握手的队列，一个是未完成3次握手的队列。，当调用accept函数时，就是从已连接的队列中取出一个已经完成3次握手的连接。<br />
</code></pre>
<p>典型的服务器程序可以同时服务于多个客户端，当有客户端发起连接时，服务器调用的accept()返回并接受这个连接，如果有大量的客户端发起连接而服务器来不及处理，尚未accept的客户端就处于连接等待状态，listen()声明sockfd处于监听状态，并且最多允许有backlog个客户端处于连接待状态，如果接收到更多的连接请求就忽略。listen()成功返回0，失败返回-1。</p>
<h3>4.accept函数</h3>
<pre class="prettyprint linenums"><code>#include &lt;sys/types.h&gt; /* See NOTES */<br />
#include &lt;sys/socket.h&gt;<br />
int accept(int sockfd, struct sockaddr *addr, socklen_t *addrlen);<br />
sockdf:<br />
socket文件描述符<br />
addr:<br />
传出参数，返回链接客户端地址信息，含IP地址和端口号<br />
addrlen:<br />
传入传出参数（值-结果）,传入sizeof(addr)大小，函数返回时返回真正接收到地址结构体的大小<br />
返回值：<br />
成功返回一个新的socket文件描述符，专门用于和客户端通信，失败返回-1，设置errno

</code></pre>
<p><strong>为什么要产生新的socket呢</strong><br /><br />
原来的socket还要处理请求连接的。<br /><br />
三方握手完成后，服务器调用accept()接受连接，如果服务器调用accept()时还没有客户端的连接请求，就阻塞等待直到有客户端连接上来。addr是一个传出参数，accept()返回时传出客户端的地址和端口号。addrlen参数是一个传入传出参数（value-resultargument），传入的是调用者提供的缓冲区addr的长度以避免缓冲区溢出问题，传出的是客户端地址结构体的实际长度（有可能没有占满调用者提供的缓冲区）。如果给addr参数传NULL，表示不关心客户端的地址。</p>
<h3>5.客户端的connect函数</h3>
<pre class="prettyprint linenums"><code>#include &lt;sys/types.h&gt; /* See NOTES */<br />
#include &lt;sys/socket.h&gt;<br />
int connect(int sockfd, const struct sockaddr *addr, socklen_t addrlen);<br />
sockdf:<br />
socket文件描述符<br />
addr:<br />
传入参数，指定服务器端地址信息，含IP地址和端口号<br />
addrlen:<br />
传入参数,传入sizeof(addr)大小<br />
返回值：<br />
成功返回0，失败返回-1，设置errno<br />
</code></pre>
<p>客户端需要调用connect()连接服务器，connect和bind的参数形式一致，区别在于bind的参数是自己的地址，而connect的参数是对方的地址。connect()成功回0，出错返回-1。</p>
<h3>6.一个简单的服务器回射函数</h3>
<p>server.c</p>
<pre class="prettyprint linenums"><code>#include &lt;unistd.h&gt;<br />
#include &lt;sys/types.h&gt;<br />
#include &lt;sys/socket.h&gt;<br />
#include &lt;netinet/in.h&gt;<br />
#include &lt;arpa/inet.h&gt;<br />
#include &lt;stdlib.h&gt;<br />
#include &lt;stdio.h&gt;<br />
#include &lt;errno.h&gt;<br />
#include &lt;string.h&gt;

#define ERR_EXIT(m) \<br />
	do \<br />
	{ \<br />
		perror(m); \<br />
		exit(EXIT_FAILURE); \<br />
	}while(0)<br />
int main(void)<br />
{<br />
	int listenfd;<br />
	if ((listenfd = socket(PF_INET, SOCK_STREAM, IPPROTO_TCP)) &lt; 0)<br />
		ERR_EXIT(&quot;socket&quot;);

	struct sockaddr_in servaddr;<br />
	memset(&amp;servaddr, 0, sizeof(servaddr));<br />
	servaddr.sin_family = AF_INET;<br />
	servaddr.sin_port = htons(5188);

	//三种方式设置ip地址<br />
	servaddr.sin_addr.s_addr = htonl(INADDR_ANY);//表示本机的任意地址<br />
	/*servaddr.sin_addr.s_addr = inet_addr(&quot;127.0.0.1&quot;);*/<br />
	/*inet_aton(&quot;127.0.0.1, &amp;servaddr.sin_addr&quot;);*/<br />
	if ( bind(listenfd, (struct sockaddr *)&amp;servaddr, sizeof(servaddr)) &lt; 0 )<br />
		ERR_EXIT(&quot;bind&quot;);

	/*主动套接字是来发起连接*/<br />
	if (listen(listenfd, SOMAXCONN) &lt; 0)//一旦调用了这个函数就变成了被动套接字（接受连接）<br />
		ERR_EXIT(&quot;listen&quot;);

	struct sockaddr_in peeraddr;//对方的地址长度<br />
 	socklen_t peerlen = sizeof(peeraddr);<br />
	int conn = 0;//主动套接字<br />
	//这里少加了一个括号，调试了好长时间<br />
	if ((conn = accept(listenfd, (struct sockaddr *)&amp;peeraddr, &amp;peerlen)) &lt; 0 )<br />
		ERR_EXIT(&quot;accept&quot;);<br />
  //获取客户端的IP地址<br />
	printf(&quot;ip=%s, port =%d\n&quot;, inet_ntoa(peeraddr.sin_addr), ntohs(peeraddr.sin_port));<br />
	char recvbuf[1024];<br />
	while(1)<br />
	{<br />
		memset(recvbuf , 0, sizeof(recvbuf));<br />
		int ret = read(conn, recvbuf, sizeof(recvbuf));<br />
		if (ret &lt; 0)<br />
		{<br />
			ERR_EXIT(&quot;read&quot;);<br />
		}

		fputs(recvbuf, stdout);<br />
		write(conn, recvbuf, ret);<br />
	}<br />
	close(listenfd);<br />
	close(conn);<br />
	return 0;<br />
}

</code></pre>
<p>client.c</p>
<pre class="prettyprint linenums"><code>#include &lt;unistd.h&gt;<br />
#include &lt;sys/types.h&gt;<br />
#include &lt;sys/socket.h&gt;<br />
#include &lt;netinet/in.h&gt;<br />
#include &lt;arpa/inet.h&gt;<br />
#include &lt;stdlib.h&gt;<br />
#include &lt;stdio.h&gt;<br />
#include &lt;errno.h&gt;<br />
#include &lt;string.h&gt;

#define ERR_EXIT(m) \<br />
	do \<br />
	{\<br />
		perror(m);\<br />
		exit(EXIT_FAILURE); \<br />
	}while(0)<br />
int main(void)<br />
{<br />
	int sock;<br />
	if ((sock = socket(PF_INET, SOCK_STREAM, IPPROTO_TCP)) &lt; 0)<br />
		ERR_EXIT(&quot;socket&quot;);

	struct sockaddr_in servaddr;<br />
	memset(&amp;servaddr, 0, sizeof(servaddr));<br />
	servaddr.sin_family = AF_INET;<br />
	servaddr.sin_port = htons(5188);

	//三种方式设置ip地址<br />
	servaddr.sin_addr.s_addr = inet_addr(&quot;127.0.0.1&quot;);<br />
	if ( connect(sock, (struct sockaddr *)&amp;servaddr, sizeof(servaddr)) &lt; 0)<br />
		ERR_EXIT(&quot;connect&quot;);

	char sendbuf[1024] = &quot;aaa&quot;;<br />
	char recvbuf[1024] = {0};<br />
	while(fgets(sendbuf, sizeof(sendbuf), stdin) != NULL)<br />
	{<br />
		write(sock, sendbuf,  strlen(sendbuf));<br />
		read(sock, recvbuf, sizeof(recvbuf));

		fputs(recvbuf, stdout);<br />
		memset(recvbuf, 0, sizeof(recvbuf));<br />
		memset(sendbuf, 0, sizeof(sendbuf));<br />
	}<br />
	close(sock);<br />
	return 0;<br />
}

</code></pre>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/e9pjn7d9.html">canvas学习之API整理笔记（一）</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8o1241q.html">深入理解DOM节点类型第三篇&mdash;&mdash;注释节点和文档类型节点</a>
		</li>
						<li><a href="https://www.batexi.com/a/rql1nrx9.html">BitSet构造函数的两种特例</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8k5nm58.html">一个View的子类实例化</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9px4e4q.html">关于SQL安装问题及安装前的准备</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8oy0zxq.html">Spring Framework------&amp;gt&semi;version4&period;3&period;5-----&amp;gt&semi;Reference学习心得-----&amp;gt&semi;总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q21eoo8.html">VS  解决方案管理器和 编辑窗口同步 联动</a>
		</li>
						<li><a href="https://www.batexi.com/a/r935ewgq.html">JavaScript判断用户是通过电脑端还是移动端访问</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mnnl42q.html">实现jQuery扩展总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4ypkvnq.html">使用nodejs引用socket&period;io做聊天室</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e126wk9.html">Block介绍（二）内存管理与其他特性</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7m3ppkq.html">使用modelsim仿真DDR3时编译出错的解决方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qydlkmjq.html">WordPress Platinum SEO插件跨站脚本漏洞</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gm2w4z9.html">Chapter 02：复合 VS 继承</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jzdlzw8.html">基于HTML5 Canvas的3D动态Chart图表</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jzr7yg8.html">Xampp apache与mySQL开不了 解决办法</a>
		</li>
						<li><a href="https://www.batexi.com/a/90m5vkj8.html">【bzoj4011 hnoi2015】落忆枫音</a>
		</li>
						<li><a href="https://www.batexi.com/a/8me3djrq.html">asp&period;net core系列 31 EF管理数据库架构--必备知识 反向工程</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pwmn0y8.html">剑指Offer-- 之字形顺序打印二叉树</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxd6mxj9.html">Hanlp中N最短路径分词详细介绍</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/90m04nm8.html">从Nest到Nesk -- 模块化Node框架的实践</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zopeg3q.html">js实现短暂提示框</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ojplveq.html">js中多维数组转一维</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwjp4ny8.html">利用Node的chokidar 监听文件改变的文件。</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwjpzrz8.html">node框架express</a>
			</li>
						<li><a href="https://www.batexi.com/a/9ge6kpz8.html">vue&plus;mint-ui的微博页面&lpar;支持评论&commat;添加表情等&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/qljd77x9.html">Mego开发文档 - 数据属性生成值</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1konk69.html">新概念英语（1-135）The latest report</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zop2k3q.html">Spring Cloud的DataRest（二）</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7zv1gj9.html">【第十九篇】laydate设置起始时间，laydate设置开始时间和结束时间</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
